function [Y,Z,normalize_scalling,objs] = MDTM_sparse_impute(D,param)


K=param.K;
normalize_scalling = ones(K,1);

dimensions = size(D);


number_of_modes= param.num_of_modes;

Phi=param.Phi;

PhiType = param.PhiType;

P = param.P;

rho = param.rho;

lambda = param.lambda;

% % 

%% for chunking up sptensor/subassign which is a memory bottle neck
num_missing = length(param.mask_i);
per_assign_at_one_time=.01;
num_at_one_time =floor(num_missing*per_assign_at_one_time);
num_at_last_iter = num_missing - num_at_one_time* floor( num_missing/num_at_one_time);
num_rounds = floor( num_missing/num_at_one_time);

try
    
  count_nnz =param.count_nnz;
catch 
    
   count_nnz =0;
end


try
    
  num_iters_check =param.num_iters_check;
catch 
    
   num_iters_check =10;
end




% PhiYg{3} = Yg{3};





rng(6)

[M]= size(D);





% dicitonary decomposiiton
for i=1:number_of_modes

    if param.PhiType{i}=="not_ortho_dic"


        [U,S,V]  = svd(Phi{i});

        [rows_v, cols_v]= size(V);
        PhiPhiEV{i} = V;
        
        retained_rank = min(size(Phi{i}));
        PhiPhiLAM{i}= diag(S(1:retained_rank,1:retained_rank)).^2;

        % alternative 
    %     [Ue,Se]  = eig(Phi{i}'*Phi{i});
    %     PhiPhiEV{i} = Ue;
    %     PhiPhiLAM{i}= diag(Se);

    end



end



maxiters = 500;
dimorder = 1:number_of_modes,@(x) isequal(sort(x),1:number_of_modes);




    %initilzation    
    % creats a cell a array by the number of modes
    Gamma{dimorder(1)}=0;
    
    YPhiInitInner=zeros(K,K,number_of_modes);
    Yinit = cell(number_of_modes,1);
    
    %we skip iniilzation of the first mod
    for n = dimorder(1:end)
        
           Yinit{n}  = rand(P{n},K);
        if PhiType{n}=="not_ortho_dic" || PhiType{n}=="ortho_dic"       
           PhiYInit{n} = Phi{n}*Yinit{n};   
        % if no dictionary
        else 
           PhiYInit{n} = Yinit{n};
        end
        
        if PhiType{n}=="not_ortho_dic"
        YPhiInitInner(:,:,n)=PhiYInit{n}'*PhiYInit{n};
        else
          YPhiInitInner(:,:,n)=Yinit{n}'*Yinit{n};
        end
        Gamma{n}=0;

        
    end  
    


    

%% Set up for iterations - initializing U and the fit.
%inital guess for factor matrix 
Y = Yinit;
PhiY = PhiYInit;
YPhInner = YPhiInitInner;
Z = Y;

fit = 0;



  fprintf('\nTDD:\n');


%   fit(1) = norm(X-dictionary_recon(Y,Phi,K ,M(1),M(2),M(3)));
  
Recon_T = ktensor(normalize_scalling, PhiY);

normX = norm(D); 

objs(1,1) =  sqrt( normX^2 + norm(Recon_T)^2 - 2 * innerprod(D,Recon_T) );
objs(1,2)=0;

%% Main Loop: Iterate until convergence
    for iter = 1:maxiters

        tic;
        
        % Iterate over all N modes of the tensor
      for n = dimorder(1:end)
          
          %% Y_i update
            if PhiType{n}=="not_ortho_dic"
                
                % Calculate Unew = Phi X_(n) * khatrirao(all U except n, 'r').
                Phi_D_rao_other_factors = Phi{n}' * mttkrp(D,PhiY,n)+ rho{n}*Z{n} -Gamma{n};
                
                [Ev, pv] = eig(prod(YPhInner(:,:,[1:n-1 n+1:number_of_modes]),3), 'vector');
    
                CC = PhiPhiEV{n}'*Phi_D_rao_other_factors*Ev;
                Y{n} = CC ./ (rho{n} + PhiPhiLAM{n}*pv');
                Y{n} = PhiPhiEV{n}*Y{n}*Ev';
                
                
                PhiY{n}=Phi{n}*Y{n};

                                % Normalize each vector to prevent singularities in coefmatrix
                if iter == 1
                    normalize_scalling = sqrt(sum(Y{n}.^2,1))'; %2-norm
                else
                    normalize_scalling = max( max(abs(Y{n}),[],1), 1 )'; %max-norm
                end            

                Y{n} = bsxfun(@rdivide, Y{n}, normalize_scalling');
                 

                
                PhiY{n}=Phi{n}*Y{n};

                
                
                YPhInner(:,:,n)=PhiY{n}'*PhiY{n};
                
                
            elseif PhiType{n}=="ortho_dic"
                
                % Calculate Unew = Phi D_(n) * khatrirao(all U except n, 'r').
                Phi_D_rao_other_factors = Phi{n}' * mttkrp(D,PhiY,n)+ rho{n}*Z{n} -Gamma{n};
                
                Y{n}= Phi_D_rao_other_factors/ ( prod(YPhInner(:,:,[1:n-1 n+1:number_of_modes]),3)+ rho{n}*eye(K));
                 

                
               
                % Normalize each vector to prevent singularities in coefmatrix
                if iter == 1
                    normalize_scalling = sqrt(sum(Y{n}.^2,1))'; %2-norm
                else
                    normalize_scalling = max( max(abs(Y{n}),[],1), 1 )'; %max-norm
                end            

                Y{n} = bsxfun(@rdivide, Y{n}, normalize_scalling');
                 

                 
                 PhiY{n}=Phi{n}*Y{n};
                 
%                  PhiY_new= PhiY{n};        
%                  norm(PhiY_old - PhiY_new.*normalize_scalling')
     
                 YPhInner(:,:,n)=Y{n}'*Y{n};

                
            elseif PhiType{n}=="no_dic"
                
                % Calculate Unew = D_(n) * khatrirao(all U except n, 'r').
                Y{n} = mttkrp(D,PhiY,n);


                % Compute the matrix of coefficients for linear system
                 inversion = prod(YPhInner(:,:,[1:n-1 n+1:number_of_modes]),3);
                 Y{n}= Y{n} /inversion;
                 
                 
        
                        
                % Normalize each vector to prevent singularities in coefmatrix
                if iter == 1
                    normalize_scalling = sqrt(sum(Y{n}.^2,1))'; %2-norm
                else
                    normalize_scalling = max( max(abs(Y{n}),[],1), 1 )'; %max-norm
                end            

                Y{n} = bsxfun(@rdivide, Y{n}, normalize_scalling');
                 

                
                 
                 
                 PhiY{n}=Y{n};
                 YPhInner(:,:,n)=Y{n}'*Y{n};

            else
                return
            
            end

            
            %% Z_i update
            h =Y{n}-Gamma{n}/rho{n};
            Z{n} = sign(h).*max(abs(h)-lambda{n}/rho{n},0);
            
            Gamma{n} = Gamma{n} + rho{n}*(Z{n}-Y{n});
            
            
            %if count nnz
            if count_nnz==1
                
                    nnz=0;

                    for m=1:length(dimensions)
                        nnz = nnz+ length(find(Z{m}~=0)) ;

                    end
                    
                     objs(iter,3)=nnz;
  
                
            end


              
      end

              D([param.mask_i',param.mask_j',param.mask_t'])=mask(ktensor(normalize_scalling, PhiY),param.mask_tensor);
       
             

        time_one_iter=toc;

      
       
       if(mod(iter,num_iters_check)==0)
           
           sparsity_constraint =0;
           for n= dimorder(1:end)
             sparsity_constraint = sparsity_constraint + lambda{n}*sum(abs(Y{n}),'all');
           
           end   
           
           %if we don't update the recon

           Recon_T = ktensor(normalize_scalling, PhiY);

            
            recon_error =sqrt( normX^2 + norm(Recon_T)^2 - 2 * innerprod(D,Recon_T) );
            
            fit = 1 - (recon_error / normX); %fraction explained by model
            
             objs(iter/num_iters_check+1,1)=fit;
             objs(iter/num_iters_check+1,2)=objs(iter/num_iters_check,2)+time_one_iter;
   
    
               fit_change = abs(objs(iter/num_iters_check+1,1)-objs(iter/num_iters_check,1));
               
                disp(append("iteration=" ,num2str(iter)," fit=",  num2str(fit), " f-delta=",  num2str(fit_change) ," reonstuction error=",  num2str(recon_error),...
                    " sparsity constraint=",  num2str(sparsity_constraint), " total=", num2str(objs(iter/num_iters_check+1,:))))
                

                if(fit_change<param.fitchangetol)
                    disp(" algo has met fit change tolerance ")
                   break 
                end

               
                 
       end
       
    end 
    


