
addpath(genpath("syn_gen_fun"))
addpath(genpath("tensor_toolbox-v3.5")) % modify to fit your version

%number of nodes per community
opts_syndata1.N1 =20;
%number of communites
opts_syndata1.K =10;
%internal edge
opts_syndata1.zi = 10;
%extral edge
opts_syndata1.ze  = 3;
opts_syndata1.Diag= 0;
opts_syndata1.overlap = 1;
opts_syndata1.overlap_ratio = .1;
opts_syndata1.overlap_community_pair = [1,2;2,3;3,4;4,5];


%number of nodes per community
opts_syndata2.N1 =3;
%number of communites
opts_syndata2.K =100;
%internal edge
opts_syndata2.zi = 10;
%extral edge
opts_syndata2.ze  = 3;
opts_syndata2.Diag= 0;
opts_syndata2.overlap = 0;
opts_syndata2.overlap_ratio = .1;
opts_syndata2.overlap_community_pair = [1,2;2,3;3,4;4,5];



[A1,V01] =  GGGirvanNewman(opts_syndata1.N1, opts_syndata1.K,opts_syndata1.zi,...
    opts_syndata1.ze,opts_syndata1.Diag,opts_syndata1.overlap,opts_syndata1.overlap_ratio,opts_syndata1.overlap_community_pair);

[A2,V02] =  GGGirvanNewman(opts_syndata2.N1, opts_syndata2.K,opts_syndata2.zi,...
    opts_syndata2.ze,opts_syndata2.Diag,opts_syndata2.overlap,opts_syndata2.overlap_ratio,opts_syndata2.overlap_community_pair);

L1=diag(sum(A1,2))-A1;
L2=diag(sum(A2,2))-A2;

[GFT1, v]= eigs(L1,length(L1),'smallestabs');

[GFT2, v]= eigs(L2,length(L2),'smallestabs');


max_period=10;
dimension(3)=400;
PhiRAMA=Create_temp_Dictionary(max_period,dimension(3),'Ramanujan');


% Phi=(1/(t^(1/2)))*dftmtx(t);


PhiSPLIN=construct_spline_dictionary([1:dimension(3)]);


PhiGen{1} =GFT1(:,1:50);
PhiGen{2} =GFT2(:,1:30);

% PhiGen{1} =GFT1;
% PhiGen{2} =GFT2;


PhiGen{3} =PhiRAMA;
% PhiGen{3} =PhiSPLIN;




%% Define data gen


Phi{1} =GFT1;
PhiType{1}="ortho_dic";
Phi{2} =GFT2;

PhiType{2}="ortho_dic";
Phi{3}=PhiRAMA;
PhiType{3}="not_ortho_dic";




dimension(1)=length(Phi{1});
dimension(2)=length(Phi{2});


TDD_param.num_of_modes = 3;

% size of dic;
[~,P{1}] = size(Phi{1});
[~,P{2}]= size(Phi{2});
[~,P{3}] = size(Phi{3});


[~,PGen{1}] = size(PhiGen{1});
[~,PGen{2}]= size(PhiGen{2});
[~,PGen{3}] = size(PhiGen{3});


Kgen=10;

%% generate signal from given dic
YGen{1} = rand(PGen{1},Kgen);
YGen{2} = rand(PGen{2},Kgen);
YGen{3} = rand(PGen{3},Kgen);

sparsity_level=.25;
for i=3
    Gen_temp =YGen{1};
    [row,col]= size(YGen{1});
    num_zeros = round(row*col*sparsity_level);
    
    p = randperm(row*col,num_zeros);
    Gen_temp(p)=0;
    YGen{1}= Gen_temp;
end



% PhiType{1}="no_dic";
% PhiType{2}="no_dic";
% PhiType{1}="ortho_dic";
% PhiType{2}="ortho_dic";
for i=1:3
   if(PhiType{i}=="no_dic")
       
       PhiYg{i} = YGen{i};
   else
       PhiYg{i} = PhiGen{i}*YGen{i};
   end

end

X= tensor(ktensor(ones(Kgen,1), PhiYg));

save("syn_data");

